## latrace 0.5.4-1maemo1+0m5

=== Makefile ===
#  Copyright (C) 2008, 2009 Jiri Olsa <olsajiri@gmail.com>
#
#  This file is part of the latrace.
#
#  The latrace is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  The latrace is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with the latrace (file COPYING).  If not, see 
#  <http://www.gnu.org/licenses/>.


include src/autoconf.make

confdir := $(sysconfdir)/latrace.d

ifneq ($(findstring $(MAKEFLAGS),w),w)
PRINT_DIR = --no-print-directory
else # "make -w"
NO_SUBDIR = :
endif

# nice output definition
# Mostly copied from kernel and git makefiles.

ifndef V
	QUIET_CC          = @echo "  CC" $@;
	QUIET_LD          = @echo "  LD" $@;
	QUIET_LEX         = @echo "  LE" $@;
	QUIET_YACC        = @echo "  YA" $@;
	QUIET_DEP         = @echo "  DEP" $@;
	QUIET_TAGS        = @echo "  TAGS" $@;

define install
	@echo -n "  INSTALL " `echo $(ROOTDIR)$2/$(notdir $1) | sed 's:[/]\+:/:g'` ; \
	mkdir -p $(ROOTDIR)$2; \
	install -m "ugo+$3" $1 $(ROOTDIR)$2; echo
endef
define remove
	@echo "  CLEAN  " $1; $(RM) -rf $1
endef
else
define remove
	$(RM) -rf $1
endef
define install
	mkdir -p $(ROOTDIR)$2; \
	install -m "ugo+$3" $1 $(ROOTDIR)$2; echo
endef
endif


.PHONY: all clean tags install

all::

install:: all
	$(call install,doc/latrace.1,$(mandir)/man1,"r")
	$(call install,etc/latrace.d/ctype.conf,$(confdir),"r")
	$(call install,etc/latrace.d/inet.conf,$(confdir),"r")
	$(call install,etc/latrace.d/misc.conf,$(confdir),"r")
	$(call install,etc/latrace.d/typedefs.conf,$(confdir),"r")
	$(call install,etc/latrace.d/stdlib.conf,$(confdir),"r")
	$(call install,etc/latrace.d/string.conf,$(confdir),"r")
	$(call install,etc/latrace.d/ctype.conf,$(confdir),"r")
	$(call install,etc/latrace.d/ncurses.conf,$(confdir),"r")
	$(call install,etc/latrace.d/stdio.conf,$(confdir),"r")
	$(call install,etc/latrace.d/dirent.conf,$(confdir),"r")
	$(call install,etc/latrace.d/unistd.conf,$(confdir),"r")
	$(call install,etc/latrace.d/libintl.conf,$(confdir),"r")
	$(call install,etc/latrace.d/dlfcn.conf,$(confdir),"r")
	$(call install,etc/latrace.d/fcntl.conf,$(confdir),"r")
	$(call install,etc/latrace.d/getopt.conf,$(confdir),"r")
	$(call install,etc/latrace.d/signal.conf,$(confdir),"r")
	$(call install,etc/latrace.d/ioctl.conf,$(confdir),"r")
	$(call install,etc/latrace.d/socket.conf,$(confdir),"r")
	$(call install,etc/latrace.d/netdb.conf,$(confdir),"r")
	$(call install,etc/latrace.d/stat.conf,$(confdir),"r")
	$(call install,etc/latrace.d/wait.conf,$(confdir),"r")
	$(call install,etc/latrace.d/utmp.conf,$(confdir),"r")
	$(call install,etc/latrace.d/time.conf,$(confdir),"r")
	$(call install,etc/latrace.d/termios.conf,$(confdir),"r")
	$(call install,etc/latrace.d/term.conf,$(confdir),"r")
	$(call install,etc/latrace.d/syslog.conf,$(confdir),"r")
	$(call install,etc/latrace.d/pwd.conf,$(confdir),"r")
	$(call install,etc/latrace.d/libio.conf,$(confdir),"r")
	$(call install,etc/latrace.d/locale.conf,$(confdir),"r")
	$(call install,etc/latrace.d/pthread.conf,$(confdir),"r")
	$(call install,etc/latrace.conf,$(sysconfdir),"r")

ifneq ($(MAKECMDGOALS),clean)
-include deps.make
endif

# main building schema
# Module subdir (src,libsf) are supposed to fill PROGRAMS and
# OBJS variables, and rule to link the module. The top makefile
# will do the rest.

PROGRAMS=
OBJS=

include src/Makefile

INCLUDES= -Isrc -Isrc/sysdeps/$(CONFIG_SYSDEP_DIR)
ALL_CFLAGS=$(CPPFLAGS) $(CFLAGS) -O2 -fPIC -Wall $(INCLUDES) -D_GNU_SOURCE


%.o: %.c
	$(QUIET_CC)$(CC) -o $*.o -c $(ALL_CFLAGS) $<

.SECONDARY:

%.c: %.l
	$(QUIET_LEX)$(LEX) -t $< > $(basename $<).c

%.c: %.y
	$(QUIET_YACC)$(YACC) -v $< -d -o $(basename $<).c


all:: $(PROGRAMS)

clean::
	$(call remove, $(OBJS) $(PROGRAMS))
	$(call remove, src/args-bison.c src/args-flex.c src/args-bison.h src/args-bison.output)
	$(call remove, lib bin share deps.make)

mrproper:: clean
	$(call remove, src/autoconf.h src/autoconf.make tags deps.make \
		       config.log config.status configure autom4te.cache doc/latrace.1)

# dependencies
# The gcc -M depedencies generation needs to repaired to include
# subdirectory name within the target.. at least I haven't find any
# gcc option to do that.
#  - no dependency for flex and bison definitions
DEPS_OBJS=$(filter-out src/args-flex.o src/args-bison.o,$(OBJS))

deps.make:
	$(QUIET_DEP)$(RM) -f deps.make; \
	(for obj in $(DEPS_OBJS); do \
	src=`echo $$obj | sed "s/\.o/.c/"`; \
	$(CC) $(ALL_CFLAGS) -M -MT$$obj $$src;  \
	done) > deps.make


# utilities
tags:
	$(QUIET_TAGS)$(RM) -f tags; \
	ctags -R *

=== src/Makefile ===
#  Copyright (C) 2008, 2009 Jiri Olsa <olsajiri@gmail.com>
#
#  This file is part of the latrace.
#
#  The latrace is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  The latrace is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with the latrace (file COPYING).  If not, see 
#  <http://www.gnu.org/licenses/>.


# libltaudit.so 
AUDIT_BIN=libltaudit.so
AUDIT_OBJS=\
	src/audit.o \
	src/audit-init.o \
	src/fifo.o \
	src/args-bison.o \
	src/args-flex.o \
	src/args.o \
	src/output.o \
	src/objsearch.o \
	src/sysdeps/$(CONFIG_SYSDEP_DIR)/stack.o

OBJS+=$(AUDIT_OBJS)
PROGRAMS+= $(AUDIT_BIN)

$(AUDIT_BIN): $(AUDIT_OBJS)
	$(QUIET_LD)$(CC) "-Wl,-init=audit_init" -fPIC -shared -o $@ $(AUDIT_OBJS) $(AUDIT_LIBS)

install::
	$(call install,$(AUDIT_BIN),$(libdir),"rx")

# latrace binary
LATRACE_BIN=latrace
LATRACE_OBJS=\
	src/latrace.o \
	src/config.o \
	src/run.o \
	src/stats.o \
	src/fifo.o \
	src/thread.o \
	src/output.o

OBJS+=$(LATRACE_OBJS)
PROGRAMS+=$(LATRACE_BIN)
CPPFLAGS+=-DCONFIG_LIBDIR=\"$(libdir)\"
CPPFLAGS+=-DLT_ARGS_DEF_DIR=\"$(confdir)\"
CPPFLAGS+=-DLT_ARGS_DEF_CONF=\"$(sysconfdir)/latrace.conf\"

$(LATRACE_BIN): $(LATRACE_OBJS)
	$(QUIET_LD)$(CC) $(LDFLAGS) -o $@ $(LATRACE_OBJS) $(LATRACE_LIBS) $(LIBS)

install::
	$(call install,$(LATRACE_BIN),$(bindir),"rx")

=== debian/changelog ===
latrace (0.5.4-1maemo1+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Mon, 23 Mar 2009 12:55:23 +0200

latrace (0.5.4-1maemo1) unstable; urgency=low

  * Update to 0.5.4

 -- Kiryl Shutsemau <kiryl.shutsmeau@nokia.com>  Mon, 23 Mar 2009 11:52:43 +0200

latrace (0.5.3-1maemo1) unstable; urgency=low

  * Cleaned some leftover files from source package.

 -- Akos Pasztory <akos.pasztory@gmail.com>  Wed, 25 Feb 2009 17:49:40 +0200

latrace (0.5.3-1) unstable; urgency=low

  * Created Debian package.
  * Initial upload of the package. Fixes: NB#99018

 -- Akos Pasztory <akos.pasztory@gmail.com>  Wed, 25 Feb 2009 10:30:50 +0200

=== debian/control ===
Source: latrace
Section: utils
Priority: optional
Maintainer: Akos PASZTORY <akos.pasztory@gmail.com>
Standards-Version: 3.8.0
Build-Depends: flex, bison, autoconf

Package: latrace
Architecture: i386 amd64 armel
Depends: libc6 (>= 2.5) [armel i386 amd64]
Description: traces library calls in dynamically linked programs
 latrace (similar to ltrace) displays dynamic library calls of a program
 using the LD_AUDIT feature of newer glibc versions.  It is also capable to
 measure and display various statistics of dynamic calls.  If a config file
 is provided, latrace will display function arguments with detailed output
 for structures.
 .
 See also http://latrace.sourceforge.net/

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: build clean binary-arch binary-indep binary default

pkg     := latrace
pkgdir  := debian/$(pkg)
docdir  := $(pkgdir)/usr/share/doc/$(pkg)
checkdir = @test -e debian/control || ! echo wrong directory
checkuid = @test "`id -u`" -eq 0 || ! echo need root permissions

default:
build: debian/stamp-build
debian/stamp-build:
	$(checkdir)
	autoconf
	./configure --prefix=/usr --sysconfdir=/etc --libdir=/usr/lib/latrace
	make
	touch $@
clean:
	$(checkdir)
	$(checkuid)
	rm -f debian/stamp-*
	test ! -f src/autoconf.make || make mrproper
	rm -rf debian/latrace
	rm -f debian/files debian/substvars
binary-indep:
binary-arch: debian/stamp-build
	$(checkdir)
	$(checkuid)
	install -d $(pkgdir)/DEBIAN $(docdir)
	make install ROOTDIR="$(CURDIR)/$(pkgdir)"
	cd $(pkgdir) && strip --strip-unneeded -R .note -R .comment \
		usr/bin/latrace usr/lib/latrace/libltaudit.so
	cp -p ChangeLog $(docdir)/changelog
	cp -p README ReleaseNotes TODO debian/copyright $(docdir)
	cp -p debian/changelog $(docdir)/changelog.Debian
	cp -p debian/conffiles $(pkgdir)/DEBIAN
	gzip -9f $(pkgdir)/usr/share/man/man1/latrace.1
	gzip -9f $(docdir)/changelog $(docdir)/changelog.Debian
	dpkg-shlibdeps $(pkgdir)/usr/bin/latrace
	dpkg-gencontrol -P$(pkgdir)
	cd $(pkgdir) && find * -path DEBIAN -prune -o -type f -print0 | \
		xargs -r0 md5sum > DEBIAN/md5sums
	chown -R root:root $(pkgdir)
	chmod -R u+w,go=rX $(pkgdir)
	dpkg-deb -b $(pkgdir) ..
binary: binary-arch binary-indep

## latrace 0.5.10.20110523

=== Makefile ===
#  Copyright (C) 2008, 2009, 2010 Jiri Olsa <olsajiri@gmail.com>
#
#  This file is part of the latrace.
#
#  The latrace is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  The latrace is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with the latrace (file COPYING).  If not, see 
#  <http://www.gnu.org/licenses/>.


-include src/autoconf.make

confdir     := $(sysconfdir)/latrace.d
headdir     := $(sysconfdir)/latrace.d/headers
headarchdir := $(sysconfdir)/latrace.d/headers/sysdeps/$(CONFIG_SYSDEP_DIR)

# looks like DESTDIR is a standard, but prioritize ROOTDIR anyway
ifdef DESTDIR
ifndef ROOTDIR
ROOTDIR=$(DESTDIR)
endif
endif

ifneq ($(findstring $(MAKEFLAGS),w),w)
PRINT_DIR = --no-print-directory
else # "make -w"
NO_SUBDIR = :
endif

# nice output definition
# Mostly copied from kernel and git makefiles.

ifndef V
	QUIET_CC          = @echo "  CC" $@;
	QUIET_LD          = @echo "  LD" $@;
	QUIET_LEX         = @echo "  LE" $@;
	QUIET_YACC        = @echo "  YA" $@;
	QUIET_DEP         = @echo "  DEP" $@;
	QUIET_GEN         = @echo "  GEN" $@;
	QUIET_ASCIIDOC    = @echo "  ASCIIDOC" $@;
	QUIET_XMLTO       = @echo "  XMLTO" $@;
	QUIET_PKG         = @echo -n "  PKG ";
	QUIET_INSTALL     = @echo -n "  INSTALL ";
	QUIET_LN          = @echo -n "  LN ";
	QUIET_RM          = @echo -n "  CLEAN ";
	QUIET_MKDIR       = @echo -n "  MKDIR ";
endif

# install file, arguments:
#    1 - file to install
#    2 - directory to install to
#    3 - permissions
define install
	$(QUIET_INSTALL) echo $(ROOTDIR)$2/$(notdir $1) | sed 's:[/]\+:/:g'; \
	mkdir -p $(ROOTDIR)$2; \
	install -m $3 $1 $(ROOTDIR)$2;
endef

# install link, arguments:
#    1 - source
#    2 - dest
#    3 - directory
define link
	$(QUIET_LN) echo $(ROOTDIR)$3/$(notdir $2) | sed 's:[/]\+:/:g'; \
	$(RM) -f $(ROOTDIR)$3/$(notdir $2); \
	(cd $(ROOTDIR)/$3; ln -s $1 $2)
endef

# remove file/dir
define remove
	$(QUIET_RM) echo $1; $(RM) -rf $1
endef

.PHONY: all clean tags install package .FORCE-LATRACE-CFLAGS

all::

install:: all
	$(call install,etc/latrace.d/latrace.conf,$(confdir),644)
	$(call install,etc/latrace.d/headers/latrace.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/ctype.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/inet.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/misc.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/typedefs.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/stdlib.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/string.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/ctype.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/ncurses.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/stdio.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/dirent.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/unistd.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/libintl.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/dlfcn.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/fcntl.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/getopt.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/signal.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/ioctl.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/socket.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/netdb.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/stat.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/wait.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/utmp.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/time.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/termios.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/term.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/syslog.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/pwd.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/libio.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/locale.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/pthread.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/resource.h,$(headdir),644)
	$(call install,etc/latrace.d/headers/mman.h,$(headdir),644)
ifeq ($(CONFIG_SYSDEP_DIR),x86_64)
	@mkdir -p $(ROOTDIR)/$(confarch)
	$(call install,etc/latrace.d/headers/sysdeps/$(CONFIG_SYSDEP_DIR)/latrace.h,$(headarchdir),644)
	$(call install,etc/latrace.d/headers/sysdeps/$(CONFIG_SYSDEP_DIR)/syscall.h,$(headarchdir),644)
endif


ifeq (,$(filter clean mrproper,$(MAKECMDGOALS)))
-include deps.make
endif


# main building schema
# Module subdir (src,libsf) are supposed to fill PROGRAMS and
# OBJS variables, and rule to link the module. The top makefile
# will do the rest.

PROGRAMS=
OBJS=

include src/Makefile
include doc/Makefile

ifeq ($(CONFIG_ARCH_HAVE_TEST),y)
include test/Makefile
endif

INCLUDES= -I. -Isrc -Isrc/sysdeps/$(CONFIG_SYSDEP_DIR)
ALL_CFLAGS=$(CPPFLAGS) $(CFLAGS) -O2 -fPIC -Wall $(INCLUDES) -D_GNU_SOURCE


%.o: %.c LATRACE-CFLAGS
	$(QUIET_CC)$(CC) -o $*.o -c $(ALL_CFLAGS) $<

.SECONDARY:

%.c: %.l LATRACE-CFLAGS
	$(QUIET_LEX)$(LEX) -t $< > $(basename $<).c

%.c: %.y LATRACE-CFLAGS
	$(QUIET_YACC)$(YACC) -v $< -d -o $(basename $<).c


all:: $(PROGRAMS) LATRACE-CFLAGS

clean::
	$(call remove, $(OBJS) $(PROGRAMS))
	$(call remove, src/args-bison.c src/args-flex.c src/args-bison.h src/args-bison.output)
	$(call remove, src/config-bison.c src/config-flex.c src/config-bison.h src/config-bison.output)
	$(call remove, lib bin share deps.make latrace-$(CONFIG_VERSION))

mrproper::
	git clean -xdf

snapshot:
	@$(MAKE) $(PRINT_DIR) package PKG_VER=$(CONFIG_VERSION)-`date "+%m%d%Y"`

release:
	@$(MAKE) $(PRINT_DIR) package PKG_VER=$(CONFIG_VERSION)

package:
	$(QUIET_PKG)rm -f latrace-$(PKG_VER); ln -s . latrace-$(PKG_VER); \
	echo "latrace-$(PKG_VER)"; \
	for i in `git ls-tree -r --name-only HEAD`; do \
		echo "latrace-$(PKG_VER)/$$i"; \
	done | tar cjvf latrace-$(PKG_VER).tar.bz2 -T- > /dev/null 2>&1


# dependencies
# The gcc -M depedencies generation needs to repaired to include
# subdirectory name within the target.. at least I haven't find any
# gcc option to do that.
#  - no dependency for flex and bison definitions
DEPS_OBJS=$(filter-out src/args-flex.o src/args-bison.o,$(OBJS))
DEPS_OBJS:=$(filter-out src/config-bison.o src/config-flex.o,$(DEPS_OBJS))

deps.make:
	$(QUIET_DEP)$(RM) -f deps.make; \
	(for obj in $(DEPS_OBJS); do \
	src=`echo $$obj | sed "s/\.o/.c/"`; \
	$(CC) $(ALL_CFLAGS) -M -MT$$obj $$src;  \
	done) > deps.make

# utilities
tags:
	$(QUIET_GEN)$(RM) -f tags; \
	$(FIND) . -name '*.[hc]' -print | xargs ctags -a

cscope:
	$(QUIET_GEN)$(RM) -f cscope*; \
	$(FIND) . -name '*.[hc]' -print > cscope.files; \
	cscope -b -icscope.files

# detect prefix and cflags changes
TRACK_CFLAGS = $(subst ','\'',$(ALL_CFLAGS)):\
             $(prefix):$(exec_prefix):$(bindir):$(libdir):$(sysconfdir) #'

LATRACE-CFLAGS: .FORCE-LATRACE-CFLAGS
	@FLAGS='$(TRACK_CFLAGS)'; \
	if test x"$$FLAGS" != x"`cat LATRACE-CFLAGS 2>/dev/null`" ; then \
		echo "$$FLAGS" >LATRACE-CFLAGS; \
	fi

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#  Copyright (C) 2008, 2009 Jiri Olsa <olsajiri@gmail.com>
+#  Copyright (C) 2008, 2009, 2010 Jiri Olsa <olsajiri@gmail.com>
 #
 #  This file is part of the latrace.
 #
@@ -18,47 +18,67 @@
 
 
 # libltaudit.so 
-AUDIT_BIN=libltaudit.so
+AUDIT_BIN=libltaudit.so.$(CONFIG_VERSION)
+AUDIT_LDFLAGS="-Wl,-init=audit_init" "-Wl,-soname,$(AUDIT_BIN)" -fPIC -shared $(LDFLAGS)
+AUDIT_LIBS=$(LIBS) $(LEXLIB)
+
 AUDIT_OBJS=\
 	src/audit.o \
 	src/audit-init.o \
 	src/fifo.o \
+	src/output.o \
+	src/objsearch.o \
+	src/stack.o \
+	src/symbol.o \
+	src/lib-include.o
+
+ifeq ($(CONFIG_ARCH_HAVE_ARGS),y)
+AUDIT_OBJS+=\
 	src/args-bison.o \
 	src/args-flex.o \
 	src/args.o \
-	src/output.o \
-	src/objsearch.o \
 	src/sysdeps/$(CONFIG_SYSDEP_DIR)/stack.o
+endif
 
 OBJS+=$(AUDIT_OBJS)
 PROGRAMS+= $(AUDIT_BIN)
 
 $(AUDIT_BIN): $(AUDIT_OBJS)
-	$(QUIET_LD)$(CC) "-Wl,-init=audit_init" -fPIC -shared -o $@ $(AUDIT_OBJS) $(AUDIT_LIBS)
+	$(QUIET_LD)$(CC) $(CFLAGS) $(AUDIT_LDFLAGS) -o $@ $^ $(AUDIT_LIBS)
 
 install::
-	$(call install,$(AUDIT_BIN),$(libdir),"rx")
+	$(call install,$(AUDIT_BIN),$(libdir),755)
 
 # latrace binary
 LATRACE_BIN=latrace
+LATRACE_CTL=latrace-ctl
+LATRACE_LIB= $(LIBS)
+
 LATRACE_OBJS=\
 	src/latrace.o \
+	src/ctl.o \
 	src/config.o \
 	src/run.o \
 	src/stats.o \
 	src/fifo.o \
 	src/thread.o \
-	src/output.o
+	src/output.o \
+	src/config-bison.o \
+	src/config-flex.o \
+	src/lib-include.o \
+	src/tty.o
 
 OBJS+=$(LATRACE_OBJS)
 PROGRAMS+=$(LATRACE_BIN)
 CPPFLAGS+=-DCONFIG_LIBDIR=\"$(libdir)\"
-CPPFLAGS+=-DLT_ARGS_DEF_DIR=\"$(confdir)\"
-CPPFLAGS+=-DLT_ARGS_DEF_CONF=\"$(sysconfdir)/latrace.conf\"
+CPPFLAGS+=-DLT_CONF_DIR=\"$(sysconfdir)/latrace.d\"
+CPPFLAGS+=-DLT_CONF_HEADERS_DIR=\"$(sysconfdir)/latrace.d/headers\"
+CPPFLAGS+=-DLT_CONF_HEADERS_FILE=\"$(sysconfdir)/latrace.d/headers/latrace.h\"
 
 $(LATRACE_BIN): $(LATRACE_OBJS)
-	$(QUIET_LD)$(CC) $(LDFLAGS) -o $@ $(LATRACE_OBJS) $(LATRACE_LIBS) $(LIBS)
+	$(QUIET_LD)$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LATRACE_LIB)
 
 install::
-	$(call install,$(LATRACE_BIN),$(bindir),"rx")
+	$(call install,$(LATRACE_BIN),$(bindir),755)
+	$(call link,$(LATRACE_BIN),$(LATRACE_CTL),$(bindir))

=== test/Makefile ===

LDFLAGS+=-L.

lib-test-common.so: test/lib-test-common.o
	$(QUIET_LD)$(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $^

lib-test-args.so: test/lib-test-args.o
	$(QUIET_LD)$(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $^

test-common: test/test-lib.o test/test-common.o
	$(QUIET_LD)$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ lib-test-common.so

test-args: test/test-lib.o test/test-args.o test/sysdeps/$(CONFIG_SYSDEP_DIR)/test-args.o
	$(QUIET_LD)$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ lib-test-args.so

OBJS+=test/test-lib.o

OBJS+=\
	test/lib-test-args.o \
	test/test-args.o \
	test/sysdeps/$(CONFIG_SYSDEP_DIR)/test-args.o

OBJS+=\
	test/lib-test-common.o \
	test/test-common.o

PROGRAMS+=lib-test-common.so test-common
PROGRAMS+=lib-test-args.so test-args

## latrace 0.5.11

=== Makefile ===
--- 
+++ 
@@ -147,7 +147,8 @@
 endif
 
 INCLUDES= -I. -Isrc -Isrc/sysdeps/$(CONFIG_SYSDEP_DIR)
-ALL_CFLAGS=$(CPPFLAGS) $(CFLAGS) -O2 -fPIC -Wall $(INCLUDES) -D_GNU_SOURCE
+ALL_CFLAGS=$(CPPFLAGS) $(CFLAGS) -O2 -fPIC -Wall $(INCLUDES)
+ALL_CFLAGS+=-D_GNU_SOURCE -imacros src/autoconf.h
 
 
 %.o: %.c LATRACE-CFLAGS
@@ -166,8 +167,6 @@
 
 clean::
 	$(call remove, $(OBJS) $(PROGRAMS))
-	$(call remove, src/args-bison.c src/args-flex.c src/args-bison.h src/args-bison.output)
-	$(call remove, src/config-bison.c src/config-flex.c src/config-bison.h src/config-bison.output)
 	$(call remove, lib bin share deps.make latrace-$(CONFIG_VERSION))
 
 mrproper::
@@ -191,9 +190,7 @@
 # The gcc -M depedencies generation needs to repaired to include
 # subdirectory name within the target.. at least I haven't find any
 # gcc option to do that.
-#  - no dependency for flex and bison definitions
-DEPS_OBJS=$(filter-out src/args-flex.o src/args-bison.o,$(OBJS))
-DEPS_OBJS:=$(filter-out src/config-bison.o src/config-flex.o,$(DEPS_OBJS))
+DEPS_OBJS=$(filter-out $(OBJS_DEPS_OMIT),$(OBJS))
 
 deps.make:
 	$(QUIET_DEP)$(RM) -f deps.make; \

=== doc/Makefile ===

MANMAN=doc/latrace.1
MANTXT=doc/latrace.txt
MANXML=doc/latrace.xml
MANHTML=doc/latrace.html

.PHONY: doc man htmlman

doc: $(MANMAN) $(MANHTML)

$(MANMAN): $(MANTXT)
	$(QUIET_ASCIIDOC)$(ASCIIDOC) -f doc/asciidoc.conf -b docbook -d manpage -o $(MANXML) $(MANTXT)
	$(QUIET_XMLTO)$(XMLTO) -o doc man $(MANXML)

$(MANHTML): $(MANTXT)
	$(QUIET_ASCIIDOC)$(ASCIIDOC) -b xhtml11 -d manpage --unsafe -o $(MANHTML) $(MANTXT)

clean::
	$(call remove, $(MANXML) $(MANHTML) $(MANMAN))

ifneq ($(XMLTO),:)
install:: doc
	$(call install,$(MANMAN),$(mandir)/man1,644)
endif

=== src/Makefile ===
--- 
+++ 
@@ -42,6 +42,10 @@
 
 OBJS+=$(AUDIT_OBJS)
 PROGRAMS+= $(AUDIT_BIN)
+# no dependency for flex and bison definitions
+OBJS_DEPS_OMIT+=\
+	src/args-flex.o \
+	src/args-bison.o
 
 $(AUDIT_BIN): $(AUDIT_OBJS)
 	$(QUIET_LD)$(CC) $(CFLAGS) $(AUDIT_LDFLAGS) -o $@ $^ $(AUDIT_LIBS)
@@ -74,6 +78,10 @@
 CPPFLAGS+=-DLT_CONF_DIR=\"$(sysconfdir)/latrace.d\"
 CPPFLAGS+=-DLT_CONF_HEADERS_DIR=\"$(sysconfdir)/latrace.d/headers\"
 CPPFLAGS+=-DLT_CONF_HEADERS_FILE=\"$(sysconfdir)/latrace.d/headers/latrace.h\"
+# no dependency for flex and bison definitions
+OBJS_DEPS_OMIT+=\
+	src/config-bison.o \
+	src/config-flex.o
 
 $(LATRACE_BIN): $(LATRACE_OBJS)
 	$(QUIET_LD)$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LATRACE_LIB)
@@ -82,3 +90,7 @@
 	$(call install,$(LATRACE_BIN),$(bindir),755)
 	$(call link,$(LATRACE_BIN),$(LATRACE_CTL),$(bindir))
 
+clean::
+	$(call remove, src/config-bison.[ch] src/config-flex.c)
+	$(call remove, src/args-bison.[ch] src/args-flex.c)
+	$(call remove, src/config-bison.output src/args-bison.output)

=== test/Makefile ===

LDFLAGS+=-L.

lib-test-common.so: test/lib-test-common.o
	$(QUIET_LD)$(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $^

lib-test-args.so: test/lib-test-args.o
	$(QUIET_LD)$(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $^

lib-test-libsym1.so: test/lib-test-libsym1.o
	$(QUIET_LD)$(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $^

lib-test-libsym2.so: test/lib-test-libsym2.o
	$(QUIET_LD)$(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $^

lib-test-libsym3.so: test/lib-test-libsym3.o
	$(QUIET_LD)$(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $^

test-common: test/test-lib.o test/test-common.o
	$(QUIET_LD)$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ lib-test-common.so

test-args: test/test-lib.o test/test-args.o test/sysdeps/$(CONFIG_SYSDEP_DIR)/test-args.o
	$(QUIET_LD)$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ lib-test-args.so

test-kill: test/test-kill.o
	$(QUIET_LD)$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

test-libsym: test/test-libsym.o test/test-lib.o
	$(QUIET_LD)$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ lib-test-libsym1.so lib-test-libsym2.so lib-test-libsym3.so

OBJS+=test/test-lib.o

PROGRAMS+=\
	lib-test-args.so \
	test-args
OBJS+=\
	test/lib-test-args.o \
	test/test-args.o \
	test/sysdeps/$(CONFIG_SYSDEP_DIR)/test-args.o

PROGRAMS+=\
	lib-test-common.so \
	test-common
OBJS+=\
	test/lib-test-common.o \
	test/test-common.o

PROGRAMS+=\
	lib-test-libsym1.so \
	lib-test-libsym2.so \
	lib-test-libsym3.so \
	test-libsym
OBJS+=\
	test/test-libsym.o \
	test/lib-test-libsym1.o

PROGRAMS+=\
	test-kill
OBJS+=\
	test/test-kill.o
